// -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*-

/************************************************************************
  Copyright (c) 2001, 2002 The Regents of the University of California
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

   1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

   3. All advertising materials mentioning features or use of this
   software must display the following acknowledgement: This product
   includes software developed by the University of California, Santa
   Barbara.

   4. Neither the name of the University nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
  OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/**
 * Name    :  $RCSfile: dir_cli.h,v $ - header file for directory server remote client 
 *            library.
 * Authors :  Hong Tang, htang@cs.ucsb.edu
 *            Dept. of Computer Science, UC Santa Barbara
 * Last-Mod:  $Date: 2003/08/01 11:21:20 $
 * Version :  $Revision: 1.14 $
 *
 * ISC project contact: htang@cs.ucsb.edu,  tyang@cs.ucsb.edu
 * Web site: http://www.cs.ucsb.edu/projects/isc
 */ 

# ifndef _DIR_CLI_H_
# define _DIR_CLI_H_

// # include "udp_cli.h"
# include "dir_common.h"
# include "dir_cli_base.h"

class Udp_cli;

class SCS_DIR : public DIR_Base {
private:
	char ident[128];
	char srv_ad[16];
	int srv_pt;

	Udp_cli *dir_cli; // cached UDP socket

	int check_udp_cli();
	DIR_REQ *new_req_ident(int *len);
	DIR_RES *new_res_dummy();
	DIR_RES *hook_common(DIR_REQ *req, int req_len);

 protected:
	virtual DIR_RES *hook_query(DIR_REQ *req, int req_len);
	virtual DIR_RES *hook_del(DIR_REQ *req, int req_len);
	virtual DIR_RES *hook_setp(DIR_REQ *req, int req_len);
	virtual int change_server(char *s, int p);
	virtual void free_res(DIR_RES *res);

public:
	SCS_DIR();
	SCS_DIR(char *dir, unsigned int flags=0);
	virtual ~SCS_DIR();
	virtual int get_ident(char *id, int len);
	virtual bool good() { 
		check_udp_cli(); 
		if (dir_cli) 
			return true; 
		return false; 
	}
};

# endif
