/* -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*- */

#ifndef _SORRENTO_PROC_H
#define _SORRENTO_PROC_H

int sor_proc_init(void);
void sor_proc_cleanup(void);


/** VFS operation statistics */
struct sor_vfs_stats
{
    /* file operations */
    int open;
    int release;
    int fsync;
    int read;
    int write;
    int mmap;

    /* address space operations */
    int readpage;
    int writepage;
    int prepare_write;
    int commit_write;

    /* inode operations */
    int lookup;
    int create;
    int mknod;
    int mkdir;
    int symlink;
    int unlink;
    int rmdir;
    int rename;
    int link;
    int setattr;
    int permission;
#ifdef KERNEL_2_6
    int getattr;
#else
    int revalidate;
#endif
};

extern struct sor_vfs_stats sor_vfs_stats;

extern void reset_sor_vfs_stats(void);

#endif
