/* -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*- */

#include "debug.h"
#include <stdio.h>
#include <string.h>
#include <sys/time.h>

/** debug flag */
int sor_debug_flag;

struct sor_stats sor_stats; /**< statistics */


#ifdef __cplusplus
extern "C" {
#endif

double 
getTime()
{
	struct timeval now;
	gettimeofday(&now, NULL);
	return 1.0 * now.tv_sec + now.tv_usec * 0.000001;
}


void
reset_sor_stats()
{
    memset(&sor_stats, 0, sizeof(struct sor_stats));
}


void
print_sor_stats()
{
	printf("Sorrento File Operation Statistics:\n"
		   "=====================================\n");
	printf("%-12s %9d   %4.8f\n", "getattr", sor_stats.getattr, sor_stats.t_getattr);
	printf("%-12s %9d   %4.8f\n", "getdir", sor_stats.getdir, sor_stats.t_getdir);
	printf("%-12s %9d   %4.8f\n", "mknod", sor_stats.mknod, sor_stats.t_mknod);
	printf("%-12s %9d   %4.8f\n", "mkdir", sor_stats.mkdir, sor_stats.t_mkdir);
	printf("%-12s %9d   %4.8f\n", "unlink", sor_stats.unlink, sor_stats.t_unlink);
	printf("%-12s %9d   %4.8f\n", "rmdir", sor_stats.rmdir, sor_stats.t_rmdir);
	printf("%-12s %9d   %4.8f\n", "truncate", sor_stats.truncate, sor_stats.t_truncate);
	printf("%-12s %9d   %4.8f\n", "utime", sor_stats.utime, sor_stats.t_utime);
	printf("%-12s %9d   %4.8f\n", "open", sor_stats.open, sor_stats.t_open);
	printf("%-12s %9d   %4.8f\n", "read", sor_stats.read, sor_stats.t_read);
	printf("%-12s %9d   %4.8f\n", "write", sor_stats.write, sor_stats.t_write);
	printf("%-12s %9d   %4.8f\n", "release", sor_stats.release, sor_stats.t_release);
	printf("%-12s %9d   %4.8f\n", "fsync", sor_stats.fsync, sor_stats.t_fsync);
	printf("\n\n");

	fflush(stdout);
}

#ifdef __cplusplus
}
#endif
