/**
 * Server module.
 * Author: Aziz Gulbeden
 * June 2003
 */

# include <unistd.h>
# include <stdlib.h>
# include <iostream>
# include <string>
# include <signal.h>

# include "server.h"
# include "subscriber.h"
# include "sorrento_conf.h"
# include "tmpi_debug.h"

using namespace std;

//struct Options {
//};

//static Options options;

//static int parse_cmd_args(int argc, char *argv[], Options &options, int &next_arg);

int main(int argc, char *argv[])
{
	//int next_arg;
	//parse_cmd_args(argc, argv, options, next_arg);
	//if (options.opt_f()) { // -f configuration file
	//	parse_config_file(options.opt_f(), options);
	//}

	if (argc != 2) {
		printf("Usage: %s <config>.\n", argv[0]);
		exit(-1);
	}

	try {
		SorrentoConf sconf(argv[1]);
		Proxy proxy(sconf);
		Server server(sconf, &proxy);

		signal(SIGPIPE, SIG_IGN);
		tmpi_set_dbg_level(DBG_VERBOSE-1);

		proxy.start();
		server.start();

		while ((proxy.is_running()) && (server.is_running())) {
			sleep(3);
		}

		server.stop();
		sleep(2);
		proxy.stop();

		/**
		int i;
		cin >> i;

		server.stop();
		**/
		server.finalize();
		proxy.finalize();

		sleep (3); /* to see quit messages */

		//Proxy *proxy=NULL;
		//if ( (!options.opt_s()) && (!option.opt_p()) ) {
		// at least one of the -s or -p
		// must be specified.
		//	return error;
		//}
		//if (options.opt_s()) {
		//	server=new Server(options);
		//}
		//if (options.opt_p()) {
		//	proxy=new Porxy(options);
		//}
		// ...

		//daemonize();
		//set_sig_handlers(); // kill by setting signals.

		//server.start();
		//proxy.start();

		//while (1) {
		//	if (should_quit()) {
		//		break;
		//	}
		//
		//	if (everything_okay()) {
		//	      sleep(5);
		//	}
		//	else {
		//		kill_myself();
		//	}
		//}

		//server.finalize();
		//proxy.finalize();
	}
	catch (const char *errmsg) {
		printf("Got error: %s.\n", errmsg);
		exit(-1);
	}
	catch (const string &errmsg) {
		printf("Got error: %s.\n", errmsg.c_str());
		exit(-1);
	}
	catch (int errcode) {
		printf("Got error (int): %d.\n", errcode);
		exit(-1);
	}
	catch (...) {
		printf("Got unexpected error.\n");
		exit(-1);
	}

	return 0;
}
