/**
 * Synthetic test program for testing client and server.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <string.h>
#include "client.h"

#include <iostream>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/vfs.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <dirent.h>
#include <time.h>
#include <queue>

#include "gsldistrib.h"		/* from cbs */
#include "guid.h"		/* from cbs */

#define NUM 1

#define NUM_OPS 10000
#define FILE_SIZE 100000.0

using namespace std;

int verbose=1;

int main(int argc, char *argv[])
{

	int i,j;
	int f;			/* current file handle */
	int rnd;
	double rndD;

	int create;			/* number of objects to create: parameter for synthetic set */
	int read, write;		/* # of write&read operations on each object */

	/* int output; amount of informational output to print: 0-2 */
	struct timeval start_time, stop_time; /* for time measurements */
	double sec, usec, unixsec,unixusec;

	float rOverW=0;

	int crc,rec,wrc,apc,clc,opc;

	guid_t guid;

	int modular=512;
	char writeBuf[modular*NUM+1];
	char readBuf[modular*NUM+1];
	for(i=0;i<modular*NUM; i++)
		//writeBuf[i]=i%256;
		writeBuf[i]=66;

	unixusec=unixsec=0;
	crc=rec=wrc=apc=clc=opc=0;

	f=i=j=0;
	create=1;
	write=10000;
	read=10000;

	guid.data[0]=10;
	guid.data[1]=10;
	guid.data[2]=10;
	guid.data[3]=10;
	guid.data[4]=10;
	guid.data[5]=10;
	guid.data[6]=10;
	guid.data[7]=10;
	guid.data[8]=10;
	guid.data[9]=10;
	guid.data[10]=10;
	guid.data[11]=10;
	guid.data[12]=10;
	guid.data[13]=10;
	guid.data[14]=10;
	guid.data[15]=10;



	rOverW = (double)read / (double)write;

	if (argc == 2) {
		rOverW = atof(argv[1]);
	} else {
		printf("You can enter read write ratio as argument.\nUsage %s [ratio]\nTaking ratio=1.\n", argv[0]);
	}

	Client *cli;
	char server[]="node14";
	int port = 45342;
	Descriptor desc;

	cli = new Client();

	/*  SYNTHETIC TEST */
	/* * * * * * * * * */

	//srand((unsigned) time(&t));
	srand(7);

	//goto secondPart;

	/* start measuring time */
	gettimeofday(&start_time, NULL);

	for(i=0; i<create; i++) {

		cout << "(2)Server is " << server <<  " " << port <<":" <<guid.data[0]<<":" << endl;
		ServerAddr sa(server, port, port);
		cli->create(sa, guid, desc);

		/* operations */
		for(j=0; j<NUM_OPS; j++) {

			//sleep(1);
			//if (j % 10000 == 0) {
			printf("\r %3.2f", (float)j*100.0/NUM_OPS);
			fflush(stdout);
			//}

			//rndD = gsldd_flat(0, 1);
			rndD = rand()/(RAND_MAX+1.0);
			if(rndD < rOverW / (1.0 + rOverW)) {
				// read
				rec++;
				//rnd = (int)(gsldd_flat(0, 1) * 1000000.0);
				rnd = (int) (FILE_SIZE*rand()/(RAND_MAX+1.0));   /* 52 MB*/
				// vfsRead(f,modular*rnd,modular*NUM,extremeRead);
				off_seg_t read_len;
				cli->read(desc, (off_seg_t)(modular*rnd), readBuf, (off_seg_t)(modular*NUM), read_len);
				readBuf[512]='\0';

				if (verbose)
					cout << "SYNTHETIC READ:\n" << readBuf << endl;
			} else {
				// write
				wrc++;
				//rnd = (int)(gsldd_flat(0, 1) * 1000000.0);
				rnd = (int) (FILE_SIZE*rand()/(RAND_MAX+1.0));
				//vfsWrite(f, modular*rnd, modular*NUM, writeBuf);
				writeBuf[10]=rnd % 31 + 45;
				off_seg_t write_len;
				cli->write(desc, (off_seg_t)(modular*rnd), writeBuf, (off_seg_t)(modular*NUM), write_len);
			}
			//vfsFlush(0,guid);
		}
		//vfsClose(f);
	}

	/* end measuring time */
	gettimeofday(&stop_time, NULL);

	/* print timing results for vfs */
	sec=stop_time.tv_sec-start_time.tv_sec;
	usec=(sec*1000000)+stop_time.tv_usec-start_time.tv_usec;
	fprintf(stdout,"\nSynthetic Test: %d Objects, %d Writes, %d Reads",create,wrc,rec);
	fprintf(stdout,"\nSorrento Time:  %.0f microseconds.\n",usec);

	FILE *nFile;
	char fname[32];


	//exit(0);
	//secondPart:;

	srand(7);

	rec = 0;
	wrc = 0;

	/* start measuring time for UNIX */
	sprintf(fname,"%dU",f+1);

	nFile=fopen(fname,"rb+");
	if(nFile==NULL)
		nFile=fopen(fname,"wb+");

	gettimeofday(&start_time, NULL);

	for(i=0; i<create; i++) {
		f=300;
		/* operations */
		for(j=0; j<NUM_OPS; j++) {
			if (j % 10000 == 0) {
				printf("\r %3.2f", (float)j*100.0/NUM_OPS);
				fflush(stdout);
			}

			//rndD = gsldd_flat(0, 1);
			rndD=rand()/(RAND_MAX+1.0);
			if(rndD < rOverW / (1.0 + rOverW)) {
				fflush(nFile);
				// read
				rec++;
				//rnd = (int)(gsldd_flat(0, 1) * 1000000.0);
				rnd = (int) (FILE_SIZE*rand()/(RAND_MAX+1.0));
				fseek(nFile,rnd*modular,SEEK_SET);
				fread(readBuf,1, modular*NUM,nFile);
			} else {
				// write
				wrc++;
				//rnd = (int)(gsldd_flat(0, 1) * 1000000.0);
				rnd = (int) (FILE_SIZE*rand()/(RAND_MAX+1.0));
				writeBuf[10]=rnd % 31 + 45;

				fseek(nFile,rnd*modular,SEEK_SET);
				fwrite(writeBuf, 1, modular*NUM, nFile);
			}
			//fflush(nFile);
		}
		fclose(nFile);
	}

	/* end measuring time */
	gettimeofday(&stop_time, NULL);

	/* print timing results for UNIX */
	sec=stop_time.tv_sec-start_time.tv_sec;
	usec=(sec*1000000)+stop_time.tv_usec-start_time.tv_usec;
	fprintf(stdout,"\nSynthetic Test: %d Objects, %d Writes, %d Reads",create,wrc,rec);
	fprintf(stdout,"\nUNIX Time: %.0f microseconds.\n",usec);

}




static int get_mode(char *f, mode_t &m)
{
	struct stat st;
	if (lstat(f, &st)<0)
		return -1;

	m=st.st_mode;

	return 0;
}


void purge_file_cache(char *fc_purger)
{

	using namespace std;
	int phy_mem=0;
	//ResMon::MEM s;
	//if (ResMon::get_mem(&s)<0) {
	//    fprintf(stderr, "Error get_mem resource samples.\n");
	//    exit(-1);
	//}
	phy_mem=512*512*1024;

	int size=0;
	int update=0;
	queue < char * > filelist;

	filelist.push(strdup(fc_purger));

	while (!filelist.empty()) {
		char *file=filelist.front();
		filelist.pop();

		mode_t m;
		if (get_mode(file, m)<0) {
			free(file);
			continue;
		}

		if (S_ISREG(m)) {
			FILE *f_purger=fopen(file, "r");
			free(file);

			if (!f_purger) {
				continue;
			}

			while ((!feof(f_purger)) && (size<phy_mem)) {
				if (update%1000==0) {
					fprintf(stderr, "\rPurging file cache...%.2f%%   ", (double)size/phy_mem*100);
					fflush(stderr);
				}
				char garbage[4096];
				int cnt=fread(garbage, 1, 4096, f_purger);
				size+=cnt;
				update++;
			}
			fclose(f_purger);
			if (size>=phy_mem)
				break;
		} else if (S_ISDIR(m)) {
			DIR *dir=opendir(file);

			if (!dir) {
				free(file);
				continue;
			}

			struct dirent *de=NULL;
			while ((de=readdir(dir))) {
				if ((de->d_name[0]=='.')&&(de->d_name[1]=='\0'))
					continue;

				if ((de->d_name[0]=='.')&&(de->d_name[1]=='.')&&(de->d_name[2]=='\0'))
					continue;

				char ff[1024];
				snprintf(ff, 1024, "%s/%s", file, de->d_name);
				filelist.push(strdup(ff));
			}
			closedir(dir);
			free(file);
		}
	}

	if (size<phy_mem) {
		fprintf(stderr, "\nWarning: File cache purger too small.\n");
	} else {
		fprintf(stderr, "\rPurging file cache...done    \n");
	}

	return;
}

