# ifndef _MCAST_STRUCT_H_
# define _MCAST_STRUCT_H_

# include <time.h>
# include "../server/sorrento_types.h"
# include "mcast_annc.h"

/**
struct disk {
	unsigned long btotal;
	unsigned long bavail;
	unsigned long ftotal; 
	unsigned long ffree;
};
**/

struct load0 {
	char host[256];
	time_t when;
	unsigned int cputotal, user, kernel, iowait, idle; // delta in 10ms
	unsigned int cpus; // # of CPUs
	unsigned int cswitches; // delta
	unsigned int mtotal, mused, mfree, mbuffers, mcached; // memory snapshot KB
	unsigned int stotal, sfree; // memory snapshot KB
	int ndisks;
	struct DiskInfo disks[10];
};

struct load {
	char host[256];
	time_t when;
	unsigned int cputotal, user, kernel, iowait, idle; // delta in 10ms
	unsigned int cpus; // # of CPUs
	unsigned int cswitches; // delta
	unsigned int mtotal, mused, mfree, mbuffers, mcached; // memory snapshot KB
	unsigned int stotal, sfree; // memory snapshot KB
	int ndisks;
	struct DiskInfo *disks;
};

void dump_annc(Mc_anc_data *data, char *host=NULL);

# endif // _MCAST_STRUCT_H_
