/*******************************************************************************
Copyright (c) 2003 The Regents of the University of California. 
All rights reserved.

Netptune project contact: Lingkun Chu (lkchu@cs.ucsb.edu),
                          Tao Yang (tyang@cs.ucsb.edu),
                          Kai Shen (kshen@cs.rochester.edu)
Web site: http://www.cs.ucsb.edu/projects/neptune
Department of Computer Science, UC Santa Barbara.

This software is distributed to individuals for personal non-commercial 
use and to non-profit entities for non-commercial purposes only. Permission 
is also granted to commercial enterprises to use this software for evaluation 
purposes only. It is licensed on a non-exclusive basis, free of charge for 
these uses. The license is subject to the following conditions:

1. Redistribution is not permitted. UC Santa Barbara will maintain a copy 
   of this software as a directly downloadable file, available under the terms 
   of license specified in this agreement.
2. All advertising materials mentioning features or use of this software must 
   display the following acknowledgment: "This product includes software 
   developed by the University of California, Santa Barbara." 
3. Neither the name of the University nor the names of its contributors may 
   be used to endorse or promote products derived from this software without 
   specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*******************************************************************************/
/*******************************************************************************
 * FILE: config.h
 * DESCRIPTION:	This module contains all defines, typedefs, and
 *		prototypes for config.cc
 * AUTHOR: Kai Shen
 * DATE CREATED: Dec 11, 2000
 * REVISIONS:
*******************************************************************************/


#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "argdef.h"

#define MAX_LINE MAXFILENAMLEN+20

class Config
{
    char domain[MAXHOSTNAMELEN];
    char file_name[MAXFILENUMBER][MAXFILENAMLEN];
	int file_num;
	char index_name[MAXFILENAMLEN];
	char free_name[MAXFILENAMLEN];

public:
    Config(const char* fname, const char* hname);

    char* GetFilename(void) { return (char *)file_name; }
	int GetFilenum(void) { return file_num;}
	char* GetIndexname(void) { return (char *)index_name;}
	char* GetFreename(void) { return (char *) free_name;}
};

#endif	// _CONFIG_H
