/* -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*- */

#ifndef _SORRENTO_DEBUG_H
#define _SORRENTO_DEBUG_H

#include "tmpi_debug.h"

extern int sor_debug_flag;
#define DEBUG_STATS     0x1




#define PENTRY double __t_start = getTime();
#define PEXIT \
double __t_duration = getTime() - __t_start; \
if (__t_duration >= 0.01) \
    tmpi_error(DBG_INFO, "%s T[%d] %f\n", __FUNCTION__, pthread_self(), __t_duration)


/** Sorrento File Operation Statistics */
struct sor_stats{
    /* number of operations */
    int getattr;
    int getdir;
    int mknod;
    int mkdir;
    int unlink;
    int rmdir;
    int truncate;
    int utime;
    int open;
    int read;
    int write;
    int release;
    int fsync;

    /* execution time */
    double t_getattr;
    double t_getdir;
    double t_mknod;
    double t_mkdir;
    double t_unlink;
    double t_rmdir;
    double t_truncate;
    double t_utime;
    double t_open;
    double t_read;
    double t_write;
    double t_release;
    double t_fsync;
};



#ifdef __cplusplus
extern "C" {
#endif

extern double getTime();

/** Sorrento file operation statistics */
extern struct sor_stats sor_stats;

/** Reset all values to 0 */
extern void reset_sor_stats();

/** Print out all statistics */
extern void print_sor_stats();


#ifdef __cplusplus
}
#endif


#endif
