#ifndef _FREESPACELIST_H_
#define _FREESPACELIST_H_

#include "argdef.h"

struct FreeBlocks 
{
	size_t beginblock;
	int blocknum;
	struct FreeBlocks* next;
};

typedef struct FreeBlocks Free_Blocks;

typedef struct
{
	size_t beginblock;
	int blocknum;
}Save_Blocks;


class Freespace_List
{
	Free_Blocks* head;
	int ifmodify;
	
	public:
	Freespace_List();
	~Freespace_List();
	
	void Initialize(char* filename);
	void Finalize(char* filename);
	
	int Read_fromFile(char* filename);
	int Write_toFile(char* filename);
	void Print_List();

	size_t Get_Freespace(int blocknum);	
	int Return_Freespace(size_t beginblock, int blocknum);

	int Ifmodified();
};

#endif
