#ifndef _FILEINDEX_H_
#define _FILEINDEX_H_

#include "argdef.h"

struct OneItem 
{
	char url[URLLEN];
	int valid;
	int fileno;
	size_t beginblock;
	size_t endblock;
	struct OneItem* next;
};

typedef struct OneItem One_Item;

typedef struct
{
	int index;
	char url[URLLEN];
	int valid;
	int fileno;
	size_t beginblock;
	size_t endblock;
}Save_Item;

typedef struct
{
	int fileno;
	size_t beginblock;
	size_t endblock;
}File_Position;

class Index_Table
{
	One_Item index_table[TABLESIZE];
	
	public:
	size_t item_num;
	int ifmodify;
	
	public:
	Index_Table();
	~Index_Table();

	void Initialize(char* filename);
	void Finalize(char* filename);
	
	int Read_fromFile(char* filename);
	int Write_toFile(char* filename);
	void Print_Table();

	int Get_Index(char* url);
	One_Item* Locate_File(char* url);

	int Retrieve_File(char* url, File_Position* fpos);	
	int Add_File(char* url, int fileno, size_t bblock, size_t eblock);
	int Delete_File(char* url);

	int Ifmodified();
};

#endif
