#ifndef __socketopt__
#define __socketopt__

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <pthread.h>

#define READ_TIMEOUT 300
#define WRITE_TIMEOUT 300
#define CONNECT_TIMEOUT 30

/* write string to the socket;
 * return -1 if socket error ocurrs;
 * return 0 if nothing is written;
 * return the length of string written.
*/
int write_msg(int sockfd, char *buf, int size);

/* read string from the socket;
 * return -1 if socket error ocurrs;
 * return 0 if nothing is read;
 * return the length of string read.
 * * you NOT need to malloc the space for *buf, just give a pointer to char* *
 * * but you NEED to free the space of *buf *
*/
int read_msg(int sockfd, char **buf);

/* connect the server with timeout
 */
int connect_with_timeout(int sockfd, const struct sockaddr *serv_addr, socklen_t addr_len, int time);

#endif
