// -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*-

/************************************************************************
  Copyright (c) 2001, 2002 The Regents of the University of California
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

   1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

   3. All advertising materials mentioning features or use of this
   software must display the following acknowledgement: This product
   includes software developed by the University of California, Santa
   Barbara.

   4. Neither the name of the University nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
  OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/**
 * Name    :  $RCSfile: sprite_struct.h,v $ - struct definition for records in the converted
 *            Sprite trace.
 * Authors :  Hong Tang, htang@cs.ucsb.edu
 *            Dept. of Computer Science, UC Santa Barbara
 * Last-Mod:  $Date: 2002/10/08 07:32:51 $
 * Version :  $Revision: 1.2 $
 *
 * ISC project contact: htang@cs.ucsb.edu,  tyang@cs.ucsb.edu
 * Web site: http://www.cs.ucsb.edu/projects/isc
 */ 
#ifndef _SPRITE_STRUCT_H_

#define _SPRITE_STRUCT_H_

typedef struct {
	long sec;
	long usec;
} BaseType;

typedef struct {
	BaseType base;
	IDType fid;
	IDType sid;
	int mode;
	int size;
} OpenType;

typedef struct {
	BaseType base;
	IDType fid;
	int size;
} UnlinkType;

typedef struct {
	BaseType base;
	IDType fid;
} CreateType;

#define SEEK_READ 0x001
#define SEEK_WRITE 0x002

typedef struct {
	BaseType base;
	IDType sid;
	int start;
	int end;
	int rw;
} SeekType;

typedef struct {
	BaseType base;
	IDType sid;
	int size;
} CloseType;

typedef struct {
	BaseType base;
	IDType sid;
	int oldLen;
	int newLen;
} TruncateType;

typedef struct {
	BaseType base;
	IDType sid;
	int offset;
	int bytes;
} ReadWriteType;

#define SPT_OPEN 1
#define SPT_DELETE 2
#define SPT_CREATE 3
#define SPT_SEEK 4
#define SPT_CLOSE 5
#define SPT_TRUNCATE 6
#define SPT_WRITE 7
#define SPT_READ 8

#endif
