/*******************************************************************************
Copyright (c) 2003 The Regents of the University of California. 
All rights reserved.

Netptune project contact: Lingkun Chu (lkchu@cs.ucsb.edu),
                          Tao Yang (tyang@cs.ucsb.edu),
                          Kai Shen (kshen@cs.rochester.edu)
Web site: http://www.cs.ucsb.edu/projects/neptune
Department of Computer Science, UC Santa Barbara.

This software is distributed to individuals for personal non-commercial 
use and to non-profit entities for non-commercial purposes only. Permission 
is also granted to commercial enterprises to use this software for evaluation 
purposes only. It is licensed on a non-exclusive basis, free of charge for 
these uses. The license is subject to the following conditions:

1. Redistribution is not permitted. UC Santa Barbara will maintain a copy 
   of this software as a directly downloadable file, available under the terms 
   of license specified in this agreement.
2. All advertising materials mentioning features or use of this software must 
   display the following acknowledgment: "This product includes software 
   developed by the University of California, Santa Barbara." 
3. Neither the name of the University nor the names of its contributors may 
   be used to endorse or promote products derived from this software without 
   specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*******************************************************************************/
/*******************************************************************************
 * FILE: md5.h
 * DESCRIPTION:	This module contains all defines, typedefs, and
 *		prototypes for md5.c
*******************************************************************************/

#ifndef H_MD5
#define H_MD5

#include "defs.h"

/*[]-----------------------------------------[]
  |  Global preprocessor defines              |
  []-----------------------------------------[]*/

#define MD5_LEN 16



/*[]-----------------------------------------[]
  |  Global typedefs                          |
  []-----------------------------------------[]*/



/*[]-----------------------------------------[]
  |  Global variables                         |
  []-----------------------------------------[]*/

extern ub1 zeromd5[MD5_LEN];



/*[]-----------------------------------------[]
  |  Global functions                         |
  []-----------------------------------------[]*/

class Md5Stream {

public:
    Md5Stream();
    ~Md5Stream() {}

    void reset(void);
    void stuff(char* string, int len);
    void close(void);
    ub4  md5Hash(void);
    void md5String(ub1 digest[MD5_LEN]);

private:
    ub4  state_[4];
    ub1  buf_[64];
    int  buf_len_;
    int  tot_len_;

};


extern ub4 md5Hash(ub1* string, int len);
extern "C" void md5String(char* string, ub1 digest[MD5_LEN]);
extern "C" void md5Convert(ub1 digest[MD5_LEN], char* digits);


#endif /* H_MD5 */
