// -*- mode:C; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*-

/************************************************************************
  Copyright (c) 2001, 2002 The Regents of the University of California
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

   1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

   3. All advertising materials mentioning features or use of this
   software must display the following acknowledgement: This product
   includes software developed by the University of California, Santa
   Barbara.

   4. Neither the name of the University nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
  OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/**
 * Name    :  $RCSfile: asmalloc.h,v $ - header file for asmalloc.c, a memory checker.
 * Authors :  Max Ibel, ibel@cs.ucsb.edu,
 *            Hong Tang, htang@cs.ucsb.edu
 *            Dept. of Computer Science, UC Santa Barbara
 * Last-Mod:  $Date: 2002/10/08 07:32:52 $
 * Version :  $Revision: 1.2 $
 *
 * Orignally from the RENS active service project.
 * Extensively modified and enhanced afterwards.
 * ISC project contact: htang@cs.ucsb.edu,  tyang@cs.ucsb.edu
 * Web site: http://www.cs.ucsb.edu/projects/isc
 */ 

# ifndef AS_MALLOC_H
# define AS_MALLOC_H

# if defined(__cplusplus)
extern "C" {
# endif

# include <sys/types.h>

# define as_malloc(size) AS_Malloc1(size, __LINE__, __FILE__)
# define as_calloc(nelem, elmsize) AS_Calloc1(nelem, elmsize, __LINE__, __FILE__)
# define as_free(mem) AS_Free1(mem, __LINE__, __FILE__)
# define as_strdup(str) AS_StrDup1(str, __LINE__, __FILE__)
# define as_init() AS_InitMem()

# include "asmalloc_api.h"

# if defined(malloc)
# undef malloc
# endif

# define malloc(size) as_malloc(size)

# if defined(calloc)
# undef calloc
# endif

# define calloc(nelem, elmsize) as_calloc(nelem, elmsize)

# if defined(free)
# undef free
# endif

# define free(mem) as_free(mem)

# if defined(strdup)
# undef strdup
# endif

# define strdup(str) as_strdup(str)

# if defined(__cplusplus)
}
# endif

# endif
