# include <stdio.h>
# include "conf.h"

int main(int argc, char *argv[])
{
	if (argc==1) {
		printf("Usage: %s <config files>\n", argv[0]);
		exit(-1);
	}

	for (int i=1; i<argc; i++) {
		Configuration conf;
		if (ReadConfigFile(conf, argv[i])==false) {
			continue;
		}
		conf.Dump();

		const Configuration::Item *i=conf.Tree("Sorrento::Server::Partitions");
		if (i) {
			i=i->Child;
			while (i) {
				printf("%s\n", i->Value.c_str());
				i=i->Next;
			}
		}
	}

	return 0;
}
