// -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*-

/************************************************************************
  Copyright (c) 2001, 2002 The Regents of the University of California
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

   1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

   3. All advertising materials mentioning features or use of this
   software must display the following acknowledgement: This product
   includes software developed by the University of California, Santa
   Barbara.

   4. Neither the name of the University nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
  OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/**
 * Name    :  $RCSfile: t1.cc,v $ - persistent hashing tester I.
 * Authors :  Hong Tang, htang@cs.ucsb.edu
 *            Dept. of Computer Science, UC Santa Barbara
 * Last-Mod:  $Date: 2003/04/09 09:59:58 $
 * Version :  $Revision: 1.3 $
 *
 * ISC project contact: htang@cs.ucsb.edu,  tyang@cs.ucsb.edu
 * Web site: http://www.cs.ucsb.edu/projects/isc
 */ 
# include <iostream>
# include <stdio.h>
# include <unistd.h>
# include "pshash.h"

using namespace std;
int main()
{
	int ret=0;

	cout << "Testing object constructors/destructors." << endl;

	cout << "The size of a PSHASH object is " << sizeof(PsHash) << endl;

	unlink("t1.db");
	FILE *fp=NULL;
	PsHash *ph1=NULL, *ph2=NULL;

	fp=fopen("t1.db", "rb");
	if (fp) {
		cout << "Failed to perform per-test cleanup: cannot remove t1.db!" << endl;
		ret=-1;
		goto _exit;
	}

	ph1=new PsHash("t1.db", 4, 4, 100, 1000);
	if (!ph1||(!ph1->is_loaded())) {
		cout << "PsHash creation constructor failed!" << endl;
		ret=-1;
		goto _exit;
	}

	ph1->release();

	ph2=new PsHash("t1.db", 1000);
	if (!ph2||(!ph2->is_loaded())) {
		cout << "PsHash load constructor failed!" << endl;
		ret=-1;
		goto _exit;
	}

	cout << "Test passed!" << endl;

_exit:
	if (ph1)
		delete ph1;
	if (ph2)
		delete ph2;

	return ret;
}
