# include <stdio.h>
# include "gsldistrib.h"

int main(int argc, char *argv[])
{
	if (argc != 4) {
		printf("Usage; %s <mean> <max> <n>.\n", argv[0]);
		exit(-1);
	}

	double mean=strtod(argv[1], NULL);
	double max=strtod(argv[2], NULL);
	int n=atoi(argv[3]);

	if (max<=mean) {
		printf("Max must be greater than mean.\n");
		exit(-1);
	}

	if (n<=0) {
		printf("N must be positive.\n");
		exit(-1);
	}

	double sigma=(max-mean)/3;
	double total=0;
	Distrib_gaussian normal(sigma);
	for (int i=0; i<n; i++) {
		if ((i%10)!=0) {
			printf(", ");
		}
		double x=normal.get_one()+mean;
		total+=x;
		printf("%8.3f", x);
		if ((i+1)%10==0) {
			printf("\n");
		}
	}
	if (n%10!=0) {
		printf("\n");
	}

	printf("total=%.4f, average=%.4f\n", total, total/n);

	return 0;
}
