// -*- mode:C; tab-width:4; c-basic-offset:4; indent-tabs-mode:t -*-

/************************************************************************
  Copyright (c) 2001, 2002 The Regents of the University of California
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

   1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

   3. All advertising materials mentioning features or use of this
   software must display the following acknowledgement: This product
   includes software developed by the University of California, Santa
   Barbara.

   4. Neither the name of the University nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND THE AUTHORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
  OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/**
 * Name    :  $RCSfile: byte_order.c,v $ - testing the byte-order (endian-ness).
 * Authors :  Hong Tang, htang@cs.ucsb.edu
 *            Dept. of Computer Science, UC Santa Barbara
 * Last-Mod:  $Date: 2002/10/08 07:32:53 $
 * Version :  $Revision: 1.5 $
 *
 * ISC project contact: htang@cs.ucsb.edu,  tyang@cs.ucsb.edu
 * Web site: http://www.cs.ucsb.edu/projects/isc
 */ 
# include <stdio.h>
# include <netdb.h>
/**
# include <sys/types.h>
# include <sys/socket.h>
# include <arpa/inet.h>
# include <unistd.h>
**/
# include <netinet/in.h>
# include <string.h>
# include "sock_conn.h"

/**---8<------------------------**/

static void display_uint(unsigned int ui)
{
	printf("Network order stored in memory:\n");
	printf(" | k |k+1|k+2|k+3|\n");
	printf(" | | | | | | | | |\n");
	printf(" | V | V | V | V |\n");
	printf(" -----------------\n");
	printf(" |%3d|%3d|%3d|%3d|\n", 
			((unsigned char *)&ui)[0],	((unsigned char *)&ui)[1],
			((unsigned char *)&ui)[2],	((unsigned char *)&ui)[3]);
	printf("-------------------\n");
	printf("Network order stored in register:\n");
	printf(" ----------------- \n");
	printf(" |%3d|%3d|%3d|%3d| \n", ui&0xff, (ui>>8)&0xff, (ui>>16)&0xff, ui>>24);
	printf(" ----------------- \n");
	printf(" ^               ^ \n");
	printf(" |               | \n");
	printf("MSB             LSB\n");
	printf("OCT1=%d, OCT2=%d, OCT3=%d, OCT4=%d\n", 
			OCTET_1(ui), OCTET_2(ui), OCTET_3(ui), OCTET_4(ui));
}

int main(int argc, char *argv[])
{
	int i=1;
	struct hostent *hp;
	struct sockaddr_in sin;

	for (; i<argc; i++) {
		hp=gethostbyname(argv[i]);
		if (hp) {
			memcpy(&(sin.sin_addr), hp->h_addr_list[0], hp->h_length);
			display_uint((unsigned int)sin.sin_addr.s_addr);
		}
	}

	return 0;
}
