# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <unistd.h>

extern "C" {
# include <readline/readline.h>
# include <readline/history.h>
}

# include "sp_singleton.h"

int main(int argc, char *argv[])
{
	while (1) {
		char *l=readline("type ? for help> ");
		if (l && (l[0])) {
			add_history(l);
		}
		if (*l=='?') {
			printf("Set an association: addr:port->fd\n");
			printf("Get an association: addr:port\n");
			printf("View current associations: dump\n");
			printf("Quit: quit\n");
			free(l);
			continue;
		}

		if (strcmp(l, "quit")==0) {
			free(l);
			break;
		}

		if (strcmp(l, "dump")==0) {
			sp_client_dump();
			free(l);
			continue;
		}

		char *sz_addr=l;
		char *sz_port=strchr(l, ':');
		char *sz_fd=strstr(l, "->");
		int fd=-1;
		int port=-1;

		if (sz_port) {
			*sz_port='\0';
			sz_port++;
			port=atoi(sz_port);
		}

		if (sz_fd) {
			fd=atoi(sz_fd+2);
			if (fd<0) {
				printf("Bad fd.\n");
				free(l);
				continue;
			}
		}

		if (port < 0) {
			printf("Bad port.\n");
		}

		if (fd>0) {
			int ret=sp_client_put_one(fd, sz_addr, port);
			if (ret < 0) {
				printf("sp_client_put_one failed.\n");
			}
			else {
				printf("done.\n");
			}
		}
		else {
			int ret=sp_client_get_one(sz_addr, port);
			if (ret < 0) {
				printf("sp_client_get_one failed.\n");
			}
			else {
				printf("fd=%d.\n", ret);
			}
		}

		free(l);

	}

	return 0;
}
