/**
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <signal.h>
#include <pthread.h>
#include <inttypes.h>
**/

# include <unistd.h>
# include <errno.h>
# include <stdlib.h>
# include <signal.h>
# include <pthread.h>
# include <stdio.h>
# include <netinet/in.h>

# include "sp_server.h"
# include "sock_sr.h"

SocketPoolServer *spsrv;

static void usage(char *prog)
{
    fprintf(stderr,"The Server is compiled on %s %s\n",__DATE__,__TIME__);
    fprintf(stderr,"\tUsage: %s -p port -h\n",prog);
    fprintf(stderr,"Options:\n");
    fprintf(stderr,"\t-h:this help page.\n");
    fprintf(stderr,"\t-p:listening port.\n");
}

extern "C" void *thr(void *arg)
{    
    char *data;
    int len;
    int conn_fd = (int) arg;

	pthread_detach(pthread_self());
    if (sock_read(conn_fd, (char *)&len, sizeof(int)) !=0) {
        fprintf(stderr, "read error.\n");
		close(conn_fd);
		return NULL;
	}
    len = ntohl(len);
    data = (char *)malloc(len);
    if (data == NULL) {
        fprintf(stderr, "Out of memory: %d.\n", len);
		close(conn_fd);
        return NULL;
    }
	if (sock_read(conn_fd, data, len) != 0) {
        fprintf(stderr, "read error.\n");
		close(conn_fd);
	}
	else {
    	spsrv->put_one(conn_fd);
	}

    free(data);

    return NULL;
}

int run()
{
   int conn_fd;
   pthread_t tid;

    while (1) {
        conn_fd = spsrv->get_one(3000);
        if (conn_fd<0) {
            if (errno != ETIMEDOUT) {
                printf("Terminating: %s \n", strerror(errno));
                break;
            } else 
                continue;
        }

        pthread_create(&tid, NULL, &thr, (void *)conn_fd);
    }
    return 0;
}

int main(int argc, char *argv[])
{
    char c;
    int port = 0;

    while ((c = getopt(argc, argv, "p:h")) != EOF) {
        switch (c) {
        case 'h':
            usage(argv[0]);
            exit(1);
        case 'p':
	    port = atoi(optarg);
	    break; 
        default:
            break;
        }
    }

    if (port <= 0) {
		port=SOCK_PORT_ANY;
    }

    spsrv = new SocketPoolServer(1024, port);
	printf("Server port == %d.\n", spsrv->get_port());

    signal(SIGBUS, SIG_IGN);
    signal(SIGSEGV, SIG_IGN);
    signal(SIGPIPE, SIG_IGN);

    try {
        run();
    } catch (int e) {
        printf("error : %d - %s\n", e, strerror(errno));
    }

    return 0;
}

