/**
 * Synthetic test program
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h> 	
#include <string.h>
#include "verfs.h"

#include <iostream>

# include <sys/types.h>
# include <sys/stat.h>
# include <sys/vfs.h>
# include <sys/mman.h>
# include <fcntl.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>
# include <getopt.h>
# include <dirent.h>
//# include <sched.h>
# include <time.h>
# include <queue>


#include "../sim/gsldistrib.h"   /* from cbs */
#include "../guid/guid.h"  /* from cbs */


static int get_mode(char *f, mode_t &m)
{
    struct stat st;
    if (lstat(f, &st)<0)
        return -1;
    m=st.st_mode;
    return 0;
}


void purge_file_cache(char *fc_purger)
{

using namespace std;
    int phy_mem=0;
    //ResMon::MEM s;
    //if (ResMon::get_mem(&s)<0) {
    //    fprintf(stderr, "Error get_mem resource samples.\n");
    //    exit(-1);
    //}
    phy_mem=512*512*1024;

    int size=0;
    int update=0;
    queue < char * > filelist;

    filelist.push(strdup(fc_purger));

    while (!filelist.empty()) {
        char *file=filelist.front();
        filelist.pop();

        mode_t m;
        if (get_mode(file, m)<0) {
            free(file);
            continue;
        }

        if (S_ISREG(m)) {
            FILE *f_purger=fopen(file, "r");
            free(file);

            if (!f_purger) {
                continue;
            }

            while ((!feof(f_purger)) && (size<phy_mem)) {
                if (update%1000==0) {
                    fprintf(stderr, "\rPurging file cache...%.2f%%   ", (double)size/phy_mem*100);
                    fflush(stderr);
                }
                char garbage[4096];
                int cnt=fread(garbage, 1, 4096, f_purger);
                size+=cnt;
                update++;
            }
            fclose(f_purger);
            if (size>=phy_mem)
                break;
        }
        else if (S_ISDIR(m)) {
            DIR *dir=opendir(file);

            if (!dir) {
                free(file);
                continue;
	    }

            struct dirent *de=NULL;
            while ((de=readdir(dir))) {
                if ((de->d_name[0]=='.')&&(de->d_name[1]=='\0'))
                    continue;

                if ((de->d_name[0]=='.')&&(de->d_name[1]=='.')&&(de->d_name[2]=='\0'))
                    continue;

                char ff[1024];
                snprintf(ff, 1024, "%s/%s", file, de->d_name);
                filelist.push(strdup(ff));
            }
            closedir(dir);
            free(file);
        }
    }

    if (size<phy_mem) {
      fprintf(stderr, "\nWarning: File cache purger too small.\n");
    }
    else {
      fprintf(stderr, "\rPurging file cache...done    \n");
    }

    return;
}

struct param{
  char c;
  int desc;
};

static Verfs *vfs;

void *run(void* arg){
//   //guid_t guid;

//   int i;
//   int f; /* current file handle */
//   param *p;

//   int rnd;
//   double rndD;

//   double rOverW = 0.0;

//   int blockSize = 512;

//   char readBuffer[10*blockSize+1];
//   char writeBuffer[10*blockSize+1];

//   p = (param*)arg;
//   f = p->desc;

//   for(i=0;i<10*blockSize; i++)
//     writeBuffer[i]=p->c;
//   writeBuffer[blockSize-1]='\n';

//   //srand((unsigned) time(&t));
//   srand(p->c * p->c * p->c);

//   for(i=0;i<10;i++){
//     sleep(1);
//     rndD = rand()/(RAND_MAX+1.0);
//     rnd = (int) (10.0*rand()/(RAND_MAX+1.0));
//     if(rndD < rOverW / (1.0 + rOverW)){
//       //vfs->read(f, blockSize*rnd, blockSize, readBuffer);
//       printf("process %c read block %d\n", p->c,rnd);
//     }
//     else{
//       //vfs->write(f, blockSize*rnd, blockSize, writeBuffer);
//       printf("process %c wrote block %d\n", p->c,rnd);
//     }
//   }    
   return NULL;
}


int main(int argc, char *argv[]){

  int i;
  int P=4; // 4 threads working 

  int f;
  guid_t guid;

  pthread_t *threads;
  pthread_attr_t attr;

  param *params;

  pthread_attr_init(&attr); 
  pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);

  vfs = new Verfs();

  threads=(pthread_t *)malloc(P*sizeof(*threads));
  params = (param *)malloc(P*sizeof(*params));


  guid.data[0]=70;
  guid.data[1]=0;
  guid.data[2]=0;
  guid.data[3]=0;

  int version;
  f=vfs->create(guid, version);

  for (i=0; i<P; i++){
    //arg[i].id=i;
    params[i].c = 48+i;
    params[i].desc = f;
    pthread_create(&threads[i], &attr, run, (void *)(&params[i]));
  }

  /* Synchronize the completion of each thread. */
  for (i=0; i<P; i++){
    pthread_join(threads[i],NULL);
  }

  vfs->dumpObject(f);
  vfs->close(f);
  
}
