/** 
 * Log cleaner module, periodically dumps objects and removes expired sessions.
 * 
 * Author: Aziz Gulbeden
 */


#include <pthread.h>
#include "logcleaner.h"
#include "verfs.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <pthread.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>  /* sleep */

HashTable *verInfos;

void *clean(void* arg){
  int i;
  VersionInfo *vi;
  struct timeval currentTime, endTime;

  double sec=0, usec=0;

  while(1){
    
    sleep(2);
	gettimeofday(&currentTime, NULL);
    /* dump everything in the hashtable */
    for (i=0; i<getSize(*verInfos); i++){
      vi = Retrieve(i, *verInfos);
      if (vi!=NULL){
	//if(vi->committed){       /* should we dump uncommitted sessions? why not? */
	  vfsDumpObject(vi->GUID);
	//}

	if(!vi->committed && currentTime.tv_sec - vi->lastAccessed.tv_sec == 86400)
	  vfsRemove(vi->GUID);    /* not accessed for one day */
      }
    }
	gettimeofday(&endTime, NULL);
    printf("CLEANER FINISHED\n");
    sec=endTime.tv_sec-currentTime.tv_sec;
    usec+=(sec*1000000)+endTime.tv_usec-currentTime.tv_usec; 
	fprintf(stdout,"\nLog cleaner time %.0f\n", usec);
  }
}


void startLogCleaner(HashTable* vis){
  
  void* arg;

  pthread_t *threads;

  pthread_attr_t attr;

  verInfos = vis;

  threads=(pthread_t *)malloc(1*sizeof(*threads));
  
  pthread_attr_init(&attr); 

  pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);

  pthread_create(&threads[0], &attr, clean, (void*)arg);

}
